package org.apidesign.apifest08.currency;

import java.util.Date;

/**
 * Date util helper class.
 * @author ked
 */
final class DateUtil {

    private DateUtil() {};

    static boolean isInRange(Date instant, Date from, Date till) {
        if ((from == null || instant.equals(from) || instant.after(from)) &&
                (till == null || instant.before(till))) {
            return true;
        } else {
            return false;
        }
    }

    static boolean isRangesOverlapping(Date fromA, Date tillA, Date fromB, Date tillB) {
        if ((fromA == null && tillA == null) || (fromB == null && tillB == null)) {
            return true;
        }
        if (fromA != null && isInRange(fromA, fromB, tillB)) {
            return true;
        }
        if (tillA != null && !tillA.equals(fromB) && isInRange(tillA, fromB, tillB)) {
            return true;
        }
        if (fromB != null && isInRange(fromB, fromA, tillA)) {
            return true;
        }
        if (tillB != null && !tillB.equals(fromA) && isInRange(tillB, fromA, tillA)) {
            return true;
        }
        return false;
    }

    static Date getRangesIntersectionBottom(Date fromA, Date fromB) {
        if (fromA == null) {
            return fromB;
        }
        if (fromB == null) {
            return fromA;
        }
        if (fromA.after(fromB)) {
            return fromA;
        } else {
            return fromB;
        }
    }

    static Date getRangesIntersectionTop(Date tillA, Date tillB) {
        if (tillA == null) {
            return tillB;
        }
        if (tillB == null) {
            return tillA;
        }
        if (tillA.before(tillB)) {
            return tillA;
        } else {
            return tillB;
        }
    }
}
